using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;

namespace MDIApp.Syntax
{
    /// <summary>
    /// 
    /// </summary>
    public class Group
    {
        private GroupList parent = null;
        
        private string name;
        private System.Drawing.Color color;
        
        private Font font;
        private StringCollection strings;

        public int Index 
        {
            get 
            {
                return parent.IndexOf(this);
            }
        }

        public string Name 
        {
            get
            {
                return name;
            }
        }

        public System.Drawing.Color Color
        {
            get
            {
                return color;
            }
            set
            {
                color = value;
            }
        }
       

        public Group()
            : this("default", null, System.Drawing.SystemColors.WindowText) {}

        public Group(ref GroupList parent)
            : this(ref parent, "default", null, System.Drawing.SystemColors.WindowText) {}

        public Group(ref GroupList parent, string name, StringCollection strings, Color color)
            : this(name, strings, color) {this.parent = parent;}

        public Group(string name, StringCollection strings, Color color)
        {
            this.name = name;
            
            if (strings != null)
            {
                if (this.strings == null)
                    this.strings = new StringCollection();
                else
                    this.strings.Clear();

                foreach (string word in strings)
                {
                    this.strings.Add(word);
                }
            }
            this.color = color;
        }

        public override string ToString()
        {
            string result = name + ":";
            
            if (strings != null)
                foreach (string word in strings)
                {
                    result += " \"" + word + "\";";
                }
            return result;
        }

        public bool Contains(string text) 
        {
            if (strings == null) return false;
			return strings.Contains(text);
        }
    }
}
