using System;
using System.Collections;
using System.Collections.Specialized;
using System.Drawing;

namespace MDIApp.Syntax
{
    /// <summary>
    /// 
    /// </summary>
    public class GroupList : ArrayList
    {
        #region   !
        GroupList zis = null;
        
        public void SetZis(ref GroupList zis) 
        {
            this.zis = zis;
        }

        public GroupList() : base() 
        {
            Add(new Group(ref zis));
        }

        public Color ColorOf(string text)
        {
            return GroupTypeOf(text).Color;
        }

        public Group GroupTypeOf(string text)
        {
            foreach(Group Group in this) 
            {
                if (Group.Contains(text)) return Group;
            }
            return (Group)this[0];
        }
        
        public int intTypeOf(string text)
        {
            foreach(Group Group in this) 
            {
                if (Group.Contains(text)) return Group.Index;
            }
            return 0;
        }

        public new Group this[int index] 
        {
            get
            {
                return (Group)base[index];
            }
            set
            {
                base[index] = value;
            }
        }

        #endregion 
       
        public void LoadFromFile(string filename)
        {
            System.IO.StreamReader words = System.IO.File.OpenText(filename);
		//	System.IO.StreamWriter log = System.IO.File.CreateText("filelog.txt");
			int n = 0;
			string buf;
			string[] group = new string [8];
			StringCollection strings = new StringCollection();            
            
			this.Add(new Group(ref zis, "strings", strings, Color.Black));
			this.Add(new Group(ref zis, "comments", strings, Color.Green));

			buf = words.ReadToEnd();
			n = 8;//buf.Split('#').Length;
	//		group = new string[n];
			group = buf.Split('#');

			for (int i = 1; i <= n; i++) 
			{
				int k = group[i].Split(' ').Length;
				string[] word = new string[k];
				word = group[i].Split(' ');
		//		log.WriteLine(" " + k + " " + word[1]+ buf);
				int j;
				for (j = 1; j < k; j++) 
				{
					strings.Add(word[j]);
				}
		//		log.WriteLine(" " + k + " " + word[j - 1]+ buf);
				switch (word[0]) 
				{
					case "numbers":
						this.Add(new Group(ref zis, word[0], strings, Color.Green));
						break;
					case "delimeters":
						strings.Add(" ");
						strings.Add("\n");
						this.Add(new Group(ref zis, word[0], strings, Color.Black));
						break;
					case "keywords":
						this.Add(new Group(ref zis, word[0], strings, Color.Blue));
						break;
					case "words":
						this.Add(new Group(ref zis, word[0], strings, Color.Blue));
						break;
					case "operators":
						this.Add(new Group(ref zis, word[0], strings, Color.Blue));
						break;
					case "variables":
						this.Add(new Group(ref zis, word[0], strings, Color.Brown));
						break;
					case "constants":
						this.Add(new Group(ref zis, word[0], strings, Color.DarkRed));
						break;
					case "functions":
						this.Add(new Group(ref zis, word[0], strings, Color.Goldenrod));
						break;
				}
                strings.Clear();
			}
		}
    }
}
